<?php
/*
 *  Author: Portfolio Multimedia | @portfolio_es
 *  URL: portfolio.es/nano | @portfolio_es
 *  
 */

/*------------------------------------*\
	Módulos externos
\*------------------------------------*/

// Cargar módulos externos

/*------------------------------------*\
	Soporte del tema
\*------------------------------------*/

if (!isset($content_width))
{
    $content_width = 900;
}

if (function_exists('add_theme_support'))
{
    // Menu
    add_theme_support('menus');

    // Thumbnails
    add_theme_support('post-thumbnails');
    add_image_size('large', 700, '', true); // Large Thumbnail
    add_image_size('medium', 250, '', true); // Medium Thumbnail
    add_image_size('small', 120, '', true); // Small Thumbnail
    add_image_size('custom-size', 700, 200, true); // Custom Thumbnail Size call using the_post_thumbnail('custom-size');

    // Añadir soporte para fondos - Descomentar para usarlo.
    /*add_theme_support('custom-background', array(
	'default-color' => 'FFF',
	'default-image' => get_template_directory_uri() . '/img/bg.jpg'
    ));*/

    // Añadir soporte para custom header - Descomentar para usarlo.
    /*add_theme_support('custom-header', array(
	'default-image'			=> get_template_directory_uri() . '/img/headers/default.jpg',
	'header-text'			=> false,
	'default-text-color'		=> '000',
	'width'				=> 1000,
	'height'			=> 198,
	'random-default'		=> false,
	'wp-head-callback'		=> $wphead_cb,
	'admin-head-callback'		=> $adminhead_cb,
	'admin-preview-callback'	=> $adminpreview_cb
    ));*/

    // Añade links al header del feed RSS en post y comentarios
    add_theme_support('automatic-feed-links');

    // Idiomas
    load_theme_textdomain('portfolionano', get_template_directory() . '/languages');
}

/*------------------------------------*\
	Funciones
\*------------------------------------*/

// portfolio nano nav
function portfolionano_nav()
{
	wp_nav_menu(
	array(
		'theme_location'  => 'header-menu',
		'menu'            => '',
		'container'       => 'div',
		'container_class' => 'menu-{menu slug}-container',
		'container_id'    => '',
		'menu_class'      => 'menu',
		'menu_id'         => '',
		'echo'            => true,
		'fallback_cb'     => 'wp_page_menu',
		'before'          => '',
		'after'           => '',
		'link_before'     => '',
		'link_after'      => '',
		'items_wrap'      => '<ul>%3$s</ul>',
		'depth'           => 0,
		'walker'          => ''
		)
	);
}

// Carga de portfolio nano scripts (header.php)
function portfolionano_header_scripts()
{
    if ($GLOBALS['pagenow'] != 'wp-login.php' && !is_admin()) {


        wp_register_script('portfolionanoscripts', get_template_directory_uri() . '/js/scripts.js', array('jquery'), '1.0.0'); // Scripts personalizados
        wp_enqueue_script('portfolionanoscripts'); // Lo ponemos en cola para cargarlo correctamente
    }
}

// Ejemplo de script condicional. Si la página es tal, se carga.
function portfolionano_conditional_scripts()
{
    if (is_page('pagenamehere')) {
        wp_register_script('scriptname', get_template_directory_uri() . '/js/scriptname.js', array('jquery'), '1.0.0'); // Scripts condicionales
        wp_enqueue_script('scriptname'); // Lo ponemos en cola para cargarlo correctamente
    }
}

// Carga de estilos
function portfolionano_styles()
{
    wp_register_style('normalize', get_template_directory_uri() . '/normalize.css', array(), '1.0', 'all');
    wp_enqueue_style('normalize'); // Lo ponemos en cola para cargarlo correctamente

    wp_register_style('portfolionano', get_template_directory_uri() . '/style.css', array(), '1.0', 'all');
    wp_enqueue_style('portfolionano'); // Lo ponemos en cola para cargarlo correctamente
}

// Registro de las zonas de menus
function register_portfolionano_menu()
{
    register_nav_menus(array( // se pueden especificar varios al usar un array
        'header-menu' => __('Header Menu', 'portfolionano'), // Menú principal
        'sidebar-menu' => __('Sidebar Menu', 'portfolionano'), // Menú en barra lateral
        'extra-menu' => __('Extra Menu', 'portfolionano') // Un menú extra por si se necesita
    ));
}

// Quitamos el <div> que rodea la navegación para simplificar el código
function my_wp_nav_menu_args($args = '')
{
    $args['container'] = false;
    return $args;
}

// Quitamos  ID's de los <li> de la navegación (Deshabilitar si no se quiere)
function my_css_attributes_filter($var)
{
    return is_array($var) ? array() : '';
}

// Quitamos atributos rel inválidos en el listado de categorías
function remove_category_rel_from_category_list($thelist)
{
    return str_replace('rel="category tag"', 'rel="tag"', $thelist);
}

// Añadimos el slug de la página a la clase del body
function add_slug_to_body_class($classes)
{
    global $post;
    if (is_home()) {
        $key = array_search('blog', $classes);
        if ($key > -1) {
            unset($classes[$key]);
        }
    } elseif (is_page()) {
        $classes[] = sanitize_html_class($post->post_name);
    } elseif (is_singular()) {
        $classes[] = sanitize_html_class($post->post_name);
    }

    return $classes;
}

// Si existe la barra lateral
if (function_exists('register_sidebar'))
{
    // Define el área de Widgets 1
    register_sidebar(array(
        'name' => __('Widget Area 1', 'portfolionano'),
        'description' => __('Description for this widget-area...', 'portfolionano'),
        'id' => 'widget-area-1',
        'before_widget' => '<div id="%1$s" class="%2$s">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));

    // Define el área de Widgets 2
    register_sidebar(array(
        'name' => __('Widget Area 2', 'portfolionano'),
        'description' => __('Description for this widget-area...', 'portfolionano'),
        'id' => 'widget-area-2',
        'before_widget' => '<div id="%1$s" class="%2$s">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));
}

// Quitamos la injección del estilo de comentarios recientes en wp_head()
function my_remove_recent_comments_style()
{
    global $wp_widget_factory;
    remove_action('wp_head', array(
        $wp_widget_factory->widgets['WP_Widget_Recent_Comments'],
        'recent_comments_style'
    ));
}

// Paginación para posts. Página 1, Página 2, Página 3, con links de Anterior y Siguiente. Sin plugins
function html5wp_pagination()
{
    global $wp_query;
    $big = 999999999;
    echo paginate_links(array(
        'base' => str_replace($big, '%#%', get_pagenum_link($big)),
        'format' => '?paged=%#%',
        'current' => max(1, get_query_var('paged')),
        'total' => $wp_query->max_num_pages
    ));
}

// Función específica para Excerts 
function html5wp_index($length) // Crea resúmenes de 20 palabras para el "Excerpt" de Index posts. Llamar usando html5wp_excerpt('html5wp_index');
{
    return 20;
}

// Crea resúmenes de 20 palabras para el "Excerpt" de los custom posts. Llamar usando html5wp_excerpt('html5wp_custom_post');
function html5wp_custom_post($length)
{
    return 40;
}

// Resultado de la llamada
function html5wp_excerpt($length_callback = '', $more_callback = '')
{
    global $post;
    if (function_exists($length_callback)) {
        add_filter('excerpt_length', $length_callback);
    }
    if (function_exists($more_callback)) {
        add_filter('excerpt_more', $more_callback);
    }
    $output = get_the_excerpt();
    $output = apply_filters('wptexturize', $output);
    $output = apply_filters('convert_chars', $output);
    $output = '<p>' . $output . '</p>';
    echo $output;
}

// Añadir link de "Ver artículo" en lugar de  [...] en los excerpts
function portfolionano_blank_view_article($more)
{
    global $post;
    return '... <a class="view-article" href="' . get_permalink($post->ID) . '">' . __('View Article', 'portfolionano') . '</a>';
}

// Para quitar la barra del admin
function remove_admin_bar()
{
    return false;
}

// Quitar 'text/css' de los estilos en cola
function portfolionano_style_remove($tag)
{
    return preg_replace('~\s+type=["\'][^"\']++["\']~', '', $tag);
}

// Quitar ancho y alto de thumbnails Remove thumbnail
function remove_thumbnail_dimensions( $html )
{
    $html = preg_replace('/(width|height)=\"\d*\"\s/', "", $html);
    return $html;
}

// Customizado de Gravatar en Settings > Discussion
function portfolionanogravatar ($avatar_defaults)
{
    $myavatar = get_template_directory_uri() . '/img/gravatar.jpg';
    $avatar_defaults[$myavatar] = "Custom Gravatar";
    return $avatar_defaults;
}

// Comentarios anidados
function enable_threaded_comments()
{
    if (!is_admin()) {
        if (is_singular() AND comments_open() AND (get_option('thread_comments') == 1)) {
            wp_enqueue_script('comment-reply');
        }
    }
}

// Resultado de comentarios customizados
function portfolionanocomments($comment, $args, $depth)
{
	$GLOBALS['comment'] = $comment;
	extract($args, EXTR_SKIP);

	if ( 'div' == $args['style'] ) {
		$tag = 'div';
		$add_below = 'comment';
	} else {
		$tag = 'li';
		$add_below = 'div-comment';
	}
?>
    <!-- heads up: starting < for the html tag (li or div) in the next line: -->
    <<?php echo $tag ?> <?php comment_class(empty( $args['has_children'] ) ? '' : 'parent') ?> id="comment-<?php comment_ID() ?>">
	<?php if ( 'div' != $args['style'] ) : ?>
	<div id="div-comment-<?php comment_ID() ?>" class="comment-body">
	<?php endif; ?>
	<div class="comment-author vcard">
	<?php if ($args['avatar_size'] != 0) echo get_avatar( $comment, $args['180'] ); ?>
	<?php printf(__('<cite class="fn">%s</cite> <span class="says">says:</span>'), get_comment_author_link()) ?>
	</div>
<?php if ($comment->comment_approved == '0') : ?>
	<em class="comment-awaiting-moderation"><?php _e('Your comment is awaiting moderation.') ?></em>
	<br />
<?php endif; ?>

	<div class="comment-meta commentmetadata"><a href="<?php echo htmlspecialchars( get_comment_link( $comment->comment_ID ) ) ?>">
		<?php
			printf( __('%1$s at %2$s'), get_comment_date(),  get_comment_time()) ?></a><?php edit_comment_link(__('(Edit)'),'  ','' );
		?>
	</div>

	<?php comment_text() ?>

	<div class="reply">
	<?php comment_reply_link(array_merge( $args, array('add_below' => $add_below, 'depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
	</div>
	<?php if ( 'div' != $args['style'] ) : ?>
	</div>
	<?php endif; ?>
<?php }

/*------------------------------------*\
	Acciones + Filtros + ShortCodes
\*------------------------------------*/

// Añadir Acciones
add_action('init', 'portfolionano_header_scripts'); // Añadir scripts a wp_head
add_action('wp_enqueue_scripts', 'portfolionano_styles'); // Añadir estilos personalizados
add_action('init', 'register_portfolionano_menu'); // Añadir menús
add_action('widgets_init', 'my_remove_recent_comments_style'); // Quitar el estilo de comentarios recientes en wp_head()
add_action('init', 'html5wp_pagination'); // Añadir nuestra paginación
//add_action('wp_print_scripts', 'portfolionano_conditional_scripts'); // Añadir scripts condicionales a wp-head
// add_action('get_header', 'enable_threaded_comments'); // Activar comentarios anidados
// add_action('init', 'example_create_post_type'); // Añadir nuestro custom post type (descomentar también la función)


// QUITAR Acciones del wp-head (personalizar según gustos)
remove_action('wp_head', 'feed_links_extra', 3); // Enlaces extras de feeds rss, como los de las categorías.
remove_action('wp_head', 'feed_links', 2); // Enlaces a feeds generales: Post y Comentarios
remove_action('wp_head', 'rsd_link'); // Enlace a Really Simple Discovery service endpoint.
remove_action('wp_head', 'wlwmanifest_link'); // Enlace al archivo Windows Live Writer manifest.
remove_action('wp_head', 'index_rel_link'); // Enlace a Index rel
remove_action('wp_head', 'parent_post_rel_link', 10, 0); // Anterior link
remove_action('wp_head', 'start_post_rel_link', 10, 0); // Comienzo link
remove_action('wp_head', 'adjacent_posts_rel_link', 10, 0); // Enlaces a posts adyacentes al actual
remove_action('wp_head', 'wp_generator'); // Meta generator de WP
remove_action('wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0);  // Enlaces a posts adyacentes al actual
remove_action('wp_head', 'rel_canonical'); // Rel canonical
remove_action('wp_head', 'wp_shortlink_wp_head', 10, 0); // Short link

// Añadir Filtros

add_filter('body_class', 'add_slug_to_body_class'); // Añadir slug a la clase del body
add_filter('widget_text', 'do_shortcode'); // Permitir Shortcodes en la barra de widgets
add_filter('widget_text', 'shortcode_unautop'); // Quitar etiquetas <p> en la barra de widgets
add_filter('wp_nav_menu_args', 'my_wp_nav_menu_args'); // Quitar <div> de la etiqueta navigation.
add_filter('the_category', 'remove_category_rel_from_category_list'); // Quitar atributos rel inválidos
//add_filter('avatar_defaults', 'portfolionanogravatar'); // Añadir Gravatars personalizados en Ajustes > Discussion
// add_filter('nav_menu_css_class', 'my_css_attributes_filter', 100, 1); // Quitar las clases insertadas en los <li> de la navegación
// add_filter('nav_menu_item_id', 'my_css_attributes_filter', 100, 1); // Quitar los ids insertados en los <li> de la navegación
// add_filter('page_css_class', 'my_css_attributes_filter', 100, 1); // Quitar los ids de página insertadas en los <li> de la navegación
// add_filter('the_excerpt', 'shortcode_unautop'); // Quitar etiquetas <p> en el Excerpt manual
add_filter('the_excerpt', 'do_shortcode'); // Permitir shortcodes en el excerpt
add_filter('excerpt_more', 'portfolionano_blank_view_article'); // Añadir link de "Ver artículo" en lugar de  [...] en los excerpts
add_filter('show_admin_bar', 'remove_admin_bar'); // Quitar barra de admin
add_filter('style_loader_tag', 'portfolionano_style_remove'); // Quitar 'text/css' de los estilos en cola
add_filter('post_thumbnail_html', 'remove_thumbnail_dimensions', 10); // Quitar width y height de los thumbnails para facilitar el responsive
add_filter('image_send_to_editor', 'remove_thumbnail_dimensions', 10); // Quitar width y height de las imágenes para facilitar el responsive

// Quitar Filtros
remove_filter('the_excerpt', 'wpautop'); // Quitar etiquetas <p> de los Excerpts

// EJEMPLO DE SHORTCODES
// add_shortcode('portfolionano_shortcode_demo', 'portfolionano_shortcode_demo'); // Puedes usar [portfolionano_shortcode_demo] en Páginas y posts ahora.
// add_shortcode('portfolionano_shortcode_demo_2', 'portfolionano_shortcode_demo_2'); // Puedes usar [portfolionano_shortcode_demo_2] en Páginas y posts ahora.

// Los shortcodes se pueden anidar así
// [portfolionano_shortcode_demo] [portfolionano_shortcode_demo_2] Título de la página [/portfolionano_shortcode_demo_2] [/portfolionano_shortcode_demo]

/*------------------------------------*\
	Custom Post Types
\*------------------------------------*/

/* Creación de un custom post type, en este caso llamado portfolio nano. Para utilizarlo, descomentar.
function example_create_post_type()
{
    register_taxonomy_for_object_type('category', 'portfolio-nano'); // Register Taxonomies for Category
    register_taxonomy_for_object_type('post_tag', 'portfolio-nano');
    register_post_type('portfolio-nano', // Register Custom Post Type
        array(
        'labels' => array(
            'name' => __('portfolio nano Custom Post', 'portfolionano'), // Rename these to suit
            'singular_name' => __('portfolio nano Custom Post', 'portfolionano'),
            'add_new' => __('Add New', 'portfolionano'),
            'add_new_item' => __('Add New portfolio nano Custom Post', 'portfolionano'),
            'edit' => __('Edit', 'portfolionano'),
            'edit_item' => __('Edit portfolio nano Custom Post', 'portfolionano'),
            'new_item' => __('New portfolio nano Custom Post', 'portfolionano'),
            'view' => __('View portfolio nano Custom Post', 'portfolionano'),
            'view_item' => __('View portfolio nano Custom Post', 'portfolionano'),
            'search_items' => __('Search portfolio nano Custom Post', 'portfolionano'),
            'not_found' => __('No portfolio nano Custom Posts found', 'portfolionano'),
            'not_found_in_trash' => __('No portfolio nano Custom Posts found in Trash', 'portfolionano')
        ),
        'public' => true,
        'hierarchical' => true, // Allows your posts to behave like Hierarchy Pages
        'has_archive' => true,
        'supports' => array(
            'title',
            'editor',
            'excerpt',
            'thumbnail'
        ), // Go to Dashboard Custom portfolio nano post for supports
        'can_export' => true, // Allows export in Tools > Export
        'taxonomies' => array(
            'post_tag',
            'category'
        ) // Add Category and Post Tags support
    ));
}
*/
/*------------------------------------*\
	ShortCodes (Funciones)
\*------------------------------------*/

// Shortcode Demo con capacidad de anidado
function portfolionano_shortcode_demo($atts, $content = null)
{
    return '<div class="shortcode-demo">' . do_shortcode($content) . '</div>'; // do_shortcode permite shortcodes anidados
}

// Shortcode Demo con una simple etiqueta <h2>
function portfolionano_shortcode_demo_2($atts, $content = null) // Demo con un  H2. Permite anidado con el elemento anterior. Totalmente expandible.
{
    return '<h2>' . $content . '</h2>';
}

?>
